/*
    Fail game engine
    Copyright 2007 Antoine Chavasse <a.chavasse@gmail.com>
 
    This file is part of Fail.

    Fail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 3
    as published by the Free Software Foundation.

    Fail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "failit.h"

using namespace fail;
using namespace fail::failit;

namespace
{
	void GenerateModuleHeaderName( ostream& Out_, shared_ptr< const idlast::Namespace > pNamespace_ )
	{
		vector< string > NSNames;
		shared_ptr< const idlast::Namespace > pCurrentNS = pNamespace_;
		while( pCurrentNS->getParent() )
		{
			NSNames.push_back( pCurrentNS->getName() );
			pCurrentNS = pCurrentNS->getParent();
		}
		
		Out_ << "module_";
		vector< string >::const_reverse_iterator it;
		for( it = NSNames.rbegin(); it != NSNames.rend(); ++it )
		{
			Out_ << *it;
			
			if( ( it - NSNames.rbegin() + vector< string >::size_type( 1 ) ) < NSNames.size() )
				Out_ << '-';
		}

		Out_ << ".h";
	}

	// A comparison functor that orders classes according to their inheritance relationship that allows
	// to sort classes from the superclasses to the children classes.
	// If there is no inheritance relationship between the two classes, we compare their names instead.
	// This way two classes without an inheritance relationship aren't considered equivalent.
	// That's because it wouldn't meet the STL requirement that equivalence should be transitive: 
	// even if b don't inherit from a and c don't inherit from b, c can inherit a.
	//
	// FIXME: we should actually compare the fully qualified names, otherwise the transitivity of equivalence
	// could be violated when classes with identical names in different namespaces are involved.
	struct ClassComparer
	{
		bool operator()( shared_ptr< const idlast::Class > lhs, shared_ptr< const idlast::Class > rhs ) const
		{
			if( lhs->isSuperClassOf( rhs ) )
				return true;
			else return lhs->getName() < rhs->getName();
		}
	};
}

void fail::failit::GenerateModuleFiles( shared_ptr< const idlast::Namespace > pNamespace_ )
{
	// Build an array of namespace names, from the root namespace to the one we're interested in.

	stringstream filename;
	GenerateModuleHeaderName( filename, pNamespace_ );
	ofstream file( filename.str().c_str() );
	
	vector< string > NSNames;
	shared_ptr< const idlast::Namespace > pCurrentNS = pNamespace_;
	while( pCurrentNS->getParent() )
	{
		NSNames.push_back( pCurrentNS->getName() );
		pCurrentNS = pCurrentNS->getParent();
	}

	stringstream defname;
	vector< string >::const_reverse_iterator it;
	for( it = NSNames.rbegin(); it != NSNames.rend(); ++it )
		defname << '_' << *it;
	
	file << "//\n"
		"// Automatically generated by FailIT (Fail IDL Translator).\n"
		"//\n"
		"#ifndef MODULE" << defname.str() << "_H_\n"
		"#define MODULE" << defname.str() << "_H_\n\n"
		"#include \"core/core.h\"\n";
	
	const idlast::NamespaceDependencySet& deps = pNamespace_->getDependencies();
	idlast::NamespaceDependencySet::const_iterator depit;
	for( depit = deps.begin(); depit != deps.end(); ++depit )
	{
		file << "#include \"";
		GenerateModuleHeaderName( file, ( *depit )->shared_from_this() );
		file << "\"\n";
	}
	
	file << '\n';
	
	for( it = NSNames.rbegin(); it != NSNames.rend(); ++it )
	{
		file << "namespace " << *it;
		
		if( ( it - NSNames.rbegin() + vector< string >::size_type( 1 ) ) < NSNames.size() )
			file << " { ";
	}
	
	file << "\n"
			"{\n"
			"\tstruct fail_tag {};\n";

	for( unsigned int i = 0; i < NSNames.size(); ++i )
		file << '}';
	
	file << "\n\n";
	
	const idlast::Dictionary< idlast::Class >& Classes = pNamespace_->getClasses();
	idlast::Dictionary< idlast::Class >::const_iterator clit;
	
	for( clit = Classes.begin(); clit != Classes.end(); ++clit )
	{
		file << "#include \"" << clit->second->getName() << ".h\"\n";
		file << "#include \"traits_" << clit->second->getName() << ".h\"\n";
	}
	
	const idlast::Dictionary< idlast::Class >& Structs = pNamespace_->getStructs();
	idlast::Dictionary< idlast::Class >::const_iterator stit;	
	for( stit = Structs.begin(); stit != Structs.end(); ++stit )
	{
		file << "#include \"" << stit->second->getName() << ".h\"\n";
		file << "#include \"traits_" << stit->second->getName() << ".h\"\n";
	}
	
	file << "\n"
			"namespace fail\n"
			"{\n"
			"\ttemplate<> struct module_traits< ";
	
	stringstream FullNSName;
	for( it = NSNames.rbegin(); it != NSNames.rend(); ++it )
	{
		FullNSName << *it;
		
		if( ( it - NSNames.rbegin() + vector< string >::size_type( 1 ) ) < NSNames.size() )
			FullNSName << "::";
	}
	
	crc32 digest;
	digest.write( FullNSName.str().c_str(), FullNSName.str().size() );
	
	file << FullNSName.str() << "::fail_tag >\n"
			"\t{\n"
			"\t\tstatic uint32_t Digest() { return 0x" << std::hex << digest.result() << "; }\n"
			"\t\tstatic const char* Name() { return \"" << NSNames[0] << "\"; }\n"
			"\t\tstatic const char* FullName() { return \"" << FullNSName.str() << "\"; }\n\n"
			"\t\ttemplate< class V > static void VisitQualifiedName( V& Visitor_ )\n"
			"\t\t{\n";
	
	for( it = NSNames.rbegin(); it != NSNames.rend(); ++it )
		file << "\t\t\tVisitor_.QualifiedNameComponent( \"" << *it << "\" );\n";
	
	file <<	"\t\t}\n"
			"\n"
			"\t\ttemplate< class V > static void VisitClasses( V& Visitor_ )\n"
			"\t\t{\n";

	// Sort classes so that superclasses always come first.
	list< shared_ptr< const idlast::Class > > SortedClasses;
	for( clit = Classes.begin(); clit != Classes.end(); ++clit )
		SortedClasses.push_back( clit->second );

	SortedClasses.sort( ClassComparer() );

	list< shared_ptr< const idlast::Class > >::const_iterator sclit;

	for( sclit = SortedClasses.begin(); sclit != SortedClasses.end(); ++sclit )
	{
		file << "\t\t\tVisitor_.template Class< "
				<< FullNSName.str() << "::" << ( *sclit )->getName() << " >();\n";
	}

	SortedClasses.clear();
	for( stit = Structs.begin(); stit != Structs.end(); ++stit )
		SortedClasses.push_back( stit->second );

	SortedClasses.sort( ClassComparer() );
	
	for( sclit = SortedClasses.begin(); sclit != SortedClasses.end(); ++sclit )
	{
		file << "\t\t\tVisitor_.template Struct< "
				<< FullNSName.str() << "::" << ( *sclit )->getName() << " >();\n";
	}
	
	file << "\t\t}\n"
			"\t};\n"
			"}\n"
			"\n"
			"#endif\n";
}
